<template>
  <JDraggable
    v-slot="dragProps"
    initial-top="calc(50% - 240px)"
    initial-left="calc(50% - 175px)"
  >
    <JResizer
      v-slot="resizerProps"
      axis-y
      v-bind="$attrs"
      hide-strip
      min-resize
    >
      <div
        v-if="connectionTarget"
        v-bind="resizerProps"
        v-bg-image="{ url: chatAvatar, disable: remoteOptions.video, cdn: true }"
        class="connection-offer-wrapper"
      >
        <div
          class="remote-stream-wrapper"
          :class="{ active: remoteOptions.video && remoteStream }"
        >
          <video
            ref="remoteStreamRef"
            autoplay
            playsinline
            :muted="false"
          />
        </div>

        <div
          class="connection-offer"
          :class="{ 'remote-stream': remoteOptions.video && remoteStream }"
        >
          <ConnectionCallHeader
            v-bind="dragProps"
            :dialog-id="dialogId"
          />
          <JText
            v-if="remoteOptions.video === false"
            color="subtitle"
            type="text-2"
            weight="normal"
            class="connection-status"
          >
            <template v-if="connectionState === ConnectionStateStatus.ringing">
              {{ $t('Ringing') }}...
            </template>
            <template v-else-if="connectionState === ConnectionStateStatus.connecting">
              {{ $t('Connecting') }}...
            </template>
            <template v-else-if="connectionState === ConnectionStateStatus.connected">
              {{ $t('Connected') }}
            </template>
          </JText>
          <JText
            v-else
            color="subtitle"
            type="text-1"
            weight="normal"
            class="interlocutor-name"
          >
            <JIcon
              size="20px"
              :icon="remoteOptions.audio ? 'microphone' : 'microphoneMuted'"
              class="mr-2"
            />
            {{ chatName }}
          </JText>
          <div class="body">
            <template v-if="remoteOptions.video === false">
              <div class="avatar">
                <ConversationRoomAvatar
                  v-if="typeof chatAvatar === 'object'"
                  :chat="chatAvatar"
                />
                <UserAvatar
                  v-else
                  :avatar="chatAvatar"
                  avatar-size="full"
                  hide-status
                />
              </div>
              <JText
                color="subtitle"
                type="text-1"
                weight="normal"
                class="interlocutor-name"
              >
                <JIcon
                  size="20px"
                  :icon="remoteOptions.audio ? 'microphone' : 'microphoneMuted'"
                  class="mr-2"
                />
                {{ chatName }}
              </JText>
            </template>

            <div
              v-if="localStream && localOptions.video"
              class="local-stream-wrapper"
            >
              <video
                ref="localStreamRef"
                autoplay
                playsinline
                muted
              />
            </div>
          </div>
          <div class="footer">
            <div class="offer-action">
              <OpenChatInNewLayer
                v-slot="chatNewLayerSlotProps"
                :chat-id="connectionTargetId"
              >
                <JButton
                  v-bind="chatNewLayerSlotProps"
                  type="flat"
                  icon
                  size="m"
                  color="white"
                  class="action"
                >
                  <JIcon
                    size="20px"
                    icon="newLayer"
                  />
                </JButton>
              </OpenChatInNewLayer>
              <JText
                color="subtitle"
                type="text-2"
                weight="normal"
              >
                {{ $t('Chat') }}
              </JText>
            </div>
            <div class="offer-action">
              <JButton
                type="flat"
                icon
                size="m"
                color="white"
                class="action"
                @click="toggleVideo(connectionTargetId)"
              >
                <JIcon
                  size="20px"
                  :icon="localOptions.video ? 'camera' : 'cameraMuted'"
                />
              </JButton>
              <JText
                color="subtitle"
                type="text-2"
                weight="normal"
              >
                {{ $t('Camera') }}
              </JText>
            </div>
            <div class="offer-action">
              <JButton
                type="flat"
                icon
                size="m"
                color="white"
                class="action"
                @click="toggleAudio(connectionTargetId)"
              >
                <JIcon
                  size="20px"
                  :icon="localOptions.audio ? 'microphone' : 'microphoneMuted'"
                />
              </JButton>
              <JText
                color="subtitle"
                type="text-2"
                weight="normal"
              >
                {{ $t('Mute') }}
              </JText>
            </div>
            <div class="offer-action">
              <JButton
                type="flat"
                color="red"
                icon
                size="m"
                class="action"
                @click="$dialog.close(dialogId);"
              >
                <JIcon
                  size="26px"
                  icon="hangUp"
                />
              </JButton>
              <JText
                color="subtitle"
                type="text-2"
                weight="normal"
              >
                {{ $t('Decline') }}
              </JText>
            </div>
          </div>
        </div>
      </div>
    </JResizer>
  </JDraggable>
</template>

<script setup lang="ts">
import {
  ref,
  computed,
  inject,
  onUnmounted,
  PropType,
  watch,
  watchPostEffect,
} from 'vue';
import {
  JButton, JDraggable, JIcon, JText, JResizer,
} from '@new-jira-clone/ui/src/components';
import { DialogPlugin } from '@new-jira-clone/ui/src/plugins/dialog';
import { useSocketStore } from '@new-jira-clone/libs/src/store';
import { OpenChatInNewLayer } from '@/features/open-chat-in-new-layer';
import { UserAvatar } from '@/entities/User';
import { ConversationRoomAvatar } from '@/entities/Conversation';
import {
  ChatTypes, IChat, IGroupChat, IUser,
} from '@/shared';
import ConnectionCallHeader from './ConnectionCallHeader.vue';
import { usePeerConnection } from '../model/usePeerConnection';
import useMediaController from '../model/useMediaController';
import { useMediaStreamStore } from '../model/useMediaStreamStore';
import { ConnectionStateStatus } from '../model/consts';

const props = defineProps({
  dialogId: {
    type: Number,
    default: null,
  },
  connectionTarget: {
    type: Object as PropType<IChat | IUser>,
    required: true,
  },
});

const chatAvatar = computed(() => {
  if ('interlocutor' in props.connectionTarget) {
    return props.connectionTarget.interlocutor.avatar;
  }

  if ('type' in props.connectionTarget && props.connectionTarget.type === ChatTypes.Group) {
    return props.connectionTarget as IGroupChat;
  }

  return props.connectionTarget.avatar;
});

const chatName = computed(() => {
  if ('interlocutor' in props.connectionTarget) {
    return props.connectionTarget.interlocutor.name;
  }

  return props.connectionTarget.name;
});

const connectionTargetId = computed(() => {
  if ('interlocutor' in props.connectionTarget) {
    return props.connectionTarget.getId();
  }

  return props.connectionTarget.id;
});

const $dialog = inject('$dialog') as DialogPlugin;

const { toggleAudio, toggleVideo } = useMediaController();
const {
  getLocalStream,
  getRemoteStream,
  getLocalOptions,
  getRemoteOptions,
  getConnectionState,
} = useMediaStreamStore();

const { socket } = useSocketStore();
const { cancelConnection } = usePeerConnection();

const localStreamRef = ref(null);
const remoteStreamRef = ref(null);

const localStream = getLocalStream(connectionTargetId.value);
const remoteStream = getRemoteStream(connectionTargetId.value);
const localOptions = getLocalOptions(connectionTargetId.value);
const remoteOptions = getRemoteOptions(connectionTargetId.value);
const connectionState = getConnectionState(connectionTargetId.value);

let isStoppedCall = false;

watchPostEffect(() => {
  if (localStream.value === null) return;
  if (localStreamRef.value === null) return;

  localStreamRef.value.srcObject = localStream.value;
});

watchPostEffect(() => {
  if (remoteStream.value === null) return;
  if (remoteStreamRef.value === null) return;

  remoteStreamRef.value.srcObject = remoteStream.value;
});

watch(
  socket,
  (newSocket) => {
    newSocket?.on('stopCall', () => {
      $dialog.close(props.dialogId);
      isStoppedCall = true;
    });
  },
  {
    immediate: true,
  },
);

onUnmounted(() => {
  if (isStoppedCall === false) {
    socket.value?.emit('stopCall', { chatId: connectionTargetId.value });

    cancelConnection(connectionTargetId.value);
  }
});
</script>

<style scoped lang="scss">
.connection-offer-wrapper {
  display: flex;
  position: relative;
  width: 350px;
  height: 480px;
  overflow: hidden;
  border-radius: 8px;
  background-repeat: no-repeat;
  background-position: center;
  background-size: cover;
}

.connection-offer {
  display: flex;
  flex-direction: column;
  justify-content: space-between;
  padding-right: 16px;
  padding-bottom: 16px;
  padding-left: 16px;
  width: 100%;
  color: #fff;

  &:not(.remote-stream) {
    backdrop-filter: blur(10px);
    background: linear-gradient(0deg, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 0.7) 100%),
      linear-gradient(180deg, rgba(0, 0, 0, 0) 0%, rgba(0, 0, 0, 0.7) 100%);
  }
}

.connection-status {
  text-align: center
}

.body {
  display: flex;
  flex-direction: column;
  justify-content: center;
  align-items: center;
  position: relative;
  margin-bottom: 20px;
  height: 100%;
}

.interlocutor-name {
  display: flex;
  align-items: center;
  justify-content: center;
  z-index: 1;
}

.footer {
  display: flex;
  justify-content: center;
  column-gap: 16px;
}

.avatar {
  margin-bottom: 10px;
  width: 130px;
  height: 130px;
}

.offer-action {
  display: flex;
  flex-direction: column;
  align-items: center;
}

.action {
  margin-bottom: 2px;
}

.local-stream-wrapper {
  display: flex;
  position: absolute;
  z-index: 2;
  right: 0;
  bottom: 0;
  width: 240px;
  height: 130px;
  overflow: hidden;
  border-radius: 6px;
  border: rgba(0, 0, 0, 0.1) 1px solid;
  background-image: radial-gradient(at -9% 0%, hsla(207, 100%, 77%, 0.08) 0px, transparent 97%),
    radial-gradient(at 84% 27%, hsla(190, 97%, 51%, 0.08) 0px, transparent 86%),
    radial-gradient(at 40% 85%, hsla(330, 100%, 69%, 0.08) 0px, transparent 76%),
    radial-gradient(at 111% 81%, hsla(191, 91%, 45%, 0.08) 0px, transparent 87%);
}

.remote-stream-wrapper {
  position: absolute;
  width: 100%;
  height: 100%;
  visibility: hidden;
  background-color: #8b8a8d;

  &.active {
    visibility: visible;
  }
}

video {
  width: 100%;
  height: 100%;
  object-fit: cover;
}
</style>
